/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package nexus.core;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.ArrayList;

/**
 *
 * @author Luke
 */
public class HabboSocket {

    private HabboConnection con;
    private Socket client, server;
    private PacketHandler clientt, serverr;
    private boolean connected = true;
    private InputStream cin = null;
    private OutputStream cout = null;
    private InputStream sin = null;
    private OutputStream sout = null;
    // Queue of Packets to Client
    private final ArrayList<HabboPacket> queue_client = new ArrayList<HabboPacket>();
    // Queue of Packets to Server
    private final ArrayList<HabboPacket> queue_server = new ArrayList<HabboPacket>();

    public void sendToClient(HabboPacket packet) {
        synchronized (queue_client) {
            queue_client.add(packet);
        }
    }

    public void sendToServer(HabboPacket packet) {
        synchronized (queue_server) {
            queue_server.add(packet);
        }
    }
    private final HabboSocket me = this;

    public HabboSocket(HabboConnection con, Socket s) throws Exception {
        this.clientt = clientt;
        this.serverr = serverr;
        this.con = con;
        client = s;
        server = new Socket(con.connection_info_host, con.connection_info_port);

        cin = client.getInputStream();
        cout = client.getOutputStream();
        sin = server.getInputStream();
        sout = server.getOutputStream();

        new Thread(incoming, "HabboClient-Incoming").start();
        new Thread(outgoing, "HabboClient-Outgoing").start();
        new Thread(queue, "HabboClient-Queue").start();
    }

    public HabboConnection getConnection() {
        return con;
    }
    Runnable incoming = new Runnable() {

        byte[] buff = new byte[1024];
        int r;

        public void run() {
            try {
                while ((r = sin.read()) > -1) {
                    cout.write(r);
                    if (r == 1) {
                        break;
                    }
                }

                ByteArrayOutputStream buffer = new ByteArrayOutputStream();

                while ((r = sin.read()) > -1) {
                    if (r == 1) {
                        HabboPacket packet = new HabboPacket(buffer.toByteArray());
                        if (con.handleIncoming(me, packet)) {
                            sendToClient(packet);
                        }
                        buffer = new ByteArrayOutputStream();
                        continue;
                    }
                    buffer.write(r);
                }
            } catch (Exception ea) {
            }
            Close();
        }
    };
    Runnable queue = new Runnable() {

        public void run() {
            while (connected) {
                synchronized (queue_client) {
                    if (queue_client.size() > 0) {
                        for (HabboPacket p : queue_client) {
                            try {
                                cout.write(p.getBytes());
                                cout.write(1);
                            } catch (Exception ex) {
                            }
                        }
                        queue_client.clear();
                    }
                }
                synchronized (queue_server) {
                    if (queue_server.size() > 0) {
                        for (HabboPacket p : queue_server) {
                            try {
                                sout.write(p.getBytes());
                            } catch (Exception ex) {
                            }
                        }
                        queue_server.clear();
                    }
                }
                try {
                    Thread.sleep(1);
                } catch (Exception ex) {
                }
            }
        }
    };
    Runnable outgoing = new Runnable() {

        byte[] buff = new byte[1024];
        int r;

        public void run() {
            try {
                while ((r = cin.read(buff)) > 0) {
                    // TODO: Encryption
                    sout.write(buff, 0, r);
                }
            } catch (Exception ea) {
            }
            Close();
        }
    };

    public void Close() {
        try {
            client.close();
        } catch (Exception ea) {
        }
        try {
            server.close();
        } catch (Exception ea) {
        }
        connected = false;
    }
}
